config/routes.rb
Rails.application.routes.draw do
  resources :messages, only: %i[index new create]

  namespace :courier_server do
    resources :contact_info, only: :create
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/message.rb
class Message < ApplicationRecord
  serialize :fields
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/courier_server/contact_info_controller.rb
module CourierServer
  class ContactInfoController < ApplicationController
    protect_from_forgery with: :null_session

    def create
      external_message_id = params.require(:message_id)
      message = Message.find_by(external_message_id: external_message_id)

      response_body = message.fields || {}

      render json: response_body
    end
  end
end

app/controllers/messages_controller.rb
class MessagesController < ApplicationController
  skip_before_action :verify_authenticity_token

  def new
    rnd = rand(10000)

    @target_messageable = "user_#{rnd}"
    @to_contact_value = 'to@example.com'
    @content = "Content #{rnd}"
    @subject = "Subject #{rnd}"
  end

  def create
    courier_server_host = ENV['COURIER_SERVER_HOST'] || 'localhost'
    courier_server_port = ENV['COURIER_SERVER_PORT'] || '3000'
    courier_server = "#{courier_server_host}:#{courier_server_port}"

    server_response = Faraday.post("http://#{courier_server}/messages",
                                   message_params.to_json,
                                   'Content-Type' => 'application/json')

    external_message_id = JSON.parse(server_response.body).symbolize_keys[:id]

    message = Message.new(message_params)
    message.external_message_id = external_message_id
    message.fields = fields_params
    message.save!
  end

  private

  def message_params
    params.permit(:message_kind,
                  :target_messageable,
                  :context)
  end

  def fields_params
    params.require(:fields).permit!.to_hash
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/messages_helper.rb
module MessagesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>CourierProjectTest</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/messages/index.html.erb
<%= link_to 'New Message', new_message_path %>

app/views/messages/new.html.erb
<%= form_tag('/messages', method: 'post') do %>
  <div>
    <span>Message Kind</span><br />
    <%= radio_button_tag(:message_kind, 'order_created', true) %>
    <%= label_tag(:message_kind_order_created, 'Order Created') %><br />
    <%= radio_button_tag(:message_kind, 'order_shipped') %>
    <%= label_tag(:message_kind_order_shipped, 'Order Shipped') %><br />
  </div>

  <br />

  <div>
    <%= label_tag(:target_messageable, 'Target Messageable') %>
    <%= text_field_tag(:target_messageable, @target_messageable) %>
  </div>

  <br />

  <div>
    <%= check_box_tag('immediate') %>
    <%= label_tag(:immediate, 'Immediate Delivery') %><br />
  </div>

  <br /><br />

  <p><b>The fields below will be used during the server callback.</b></p>

  <br />

  <div>
    <span>Contact Kind</span><br />
    <%= radio_button_tag(:contact_kind, 'email', true) %>
    <%= label_tag(:contact_kind_email, 'Email') %><br />
    <%= radio_button_tag(:contact_kind, 'text_message') %>
    <%= label_tag(:contact_kind_text_message, 'Text Message') %>
  </div>

  <br />

  <div>
    <%= label_tag(:to_contact_value, 'To Contact Value') %>
    <%= text_field_tag(:to_contact_value, @to_contact_value) %>
  </div>

  <br />

  <div>
    <%= label_tag(:content, 'Message Content') %>
    <%= text_field_tag(:content, @content) %>
  </div>

  <br />

  <div>
    <%= label_tag(:subject, 'Message Subject (optional)') %>
    <%= text_field_tag(:subject, @subject) %>
  </div>

  <br /><br />

  <%= submit_tag('Send Message') %>
<% end %>